
QGIS Application - Bug report #3137

Save as shapefile fails if field names are longer than 10 characters

2010-10-20 12:36 AM - Paolo Cavallini

Status: Closed

Priority: Low

Assignee: nobody -

Category: Data Provider

Affected QGIS version: Regression?: No

Operating System: All Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed

Crashes QGIS or corrupts data: Copied to github as #: 13197

Description

If I try to save the attached [[MapInfo]] file, I get:

Export to vector file failed.

Error: trimming attribute name 'PM10_AVG_max' to ten significant characters produces duplicate column name.

and export fails. It seems a limitation of OGR, but perhaps we could be smarter and replace the last character with a serial.

Otherwise better forward this ticket to GDAL trac?

Associated revisions

Revision f708fe7c - 2011-02-21 11:41 PM - Jürgen Fischer

fix #3137

git-svn-id: http://svn.osgeo.org/qgis/trunk/qgis@15238 c8812cc2-4d05-0410-92ff-de0c093fc19c

Revision b642e809 - 2011-02-21 11:41 PM - Jürgen Fischer

fix #3137

git-svn-id: http://svn.osgeo.org/qgis/trunk@15238 c8812cc2-4d05-0410-92ff-de0c093fc19c

History

#1 - 2010-10-20 01:38 AM - Paolo Cavallini

BTW, the external plugin Table Manager fails to rename the fields, hanging QGIS

#2 - 2010-10-20 04:59 AM - Jürgen Fischer

Replying to pcav:

and export fails. It seems a limitation of OGR, but perhaps we could be smarter and replace the last character with a serial.

AFAIK it's not a limitation of OGR, but a limitation of D-Base format.
#3 - 2010-10-20 05:27 AM - Paolo Cavallini

I mean: the lack of a proper truncation method, adding a serial in case of too long field names, may be a limitation of OGR.

#4 - 2010-10-20 05:53 AM - Frank Warmerdam -

If the ticket is filed against GDAL, I can have Chaitanya look into clean logic for disambiguation for shortened names.

#5 - 2010-10-20 05:57 AM - Jürgen Fischer

If this is fixed in OGR we need to keep in mind to adapt http://trac.osgeo.org/qgis/browser/trunk/qgis/src/core/qgsvectorfilewriter.cpp#L312 accordingly.

#6 - 2010-10-20 06:26 AM - Paolo Cavallini

http://trac.osgeo.org/gdal/ticket/3796

#7 - 2010-10-20 07:25 AM - Paolo Cavallini

Apparently the problem has been solved in GDAL 1.7. The method in QGIS should then be updated. See http://trac.osgeo.org/gdal/ticket/3796#comment:1

#8 - 2011-02-21 02:42 PM - Jürgen Fischer

- Resolution set to fixed

- Status changed from Open to Closed

fixed in commit:b642e809 (SVN r15239).

Files

contour.mif.zip 10.7 KB 2010-10-19 Paolo Cavallini
